#!/usr/bin/ruby

require 'cgi/session'
require 'drb/drb'
require 'thread'

class CGI
  class Session
    class DRbMemoryStore < MemoryStore
      include DRbUndumped
      MUTEX = Mutex.new
      def initialize(session, option={})
        MUTEX.synchronize {
          super
          GLOBAL_HASH_TABLE[@session_id].extend DRbUndumped
        }
      end
      def restore
        MUTEX.synchronize {super}
      end
      def delete
        MUTEX.synchronize {super}
      end
    end
  end # Session
end # CGI

class Front
  include DRbUndumped
  def session(session, option = {})
    if $DEBUG
      puts Time.now
      puts session.inspect
      puts CGI::Session::DRbMemoryStore::GLOBAL_HASH_TABLE.inspect
    end
    CGI::Session::DRbMemoryStore.new(session, option)
  end
end

DRb.start_service('druby://localhost:8888', Front.new)
puts DRb.uri
puts '[return] to exit'
gets
